
//---------------------------------------------------------------
//  File: bmpimage.h
//
//  Defines the BMPImage class representing a Windows BMP image.
//
//---------------------------------------------------------------
#if !defined(__BMPIMAGE_H)
#define __BMPIMAGE_H

#include "image.h"
#include "ihead.h"


class BMPImage: public Image
{
public:
	 BMPImage() {}

	 ~BMPImage() {}

	 virtual int read(const char* filename);
	 virtual int convert(const char* filename);
	 virtual int get_thres_image();
	 virtual int write(const char* filename);
	 virtual int read(ifstream& ifs);
	 virtual int convert(ifstream& ifs);
	 virtual int get_image();
	 virtual int make_image(int w, int h,unsigned char huge *outdata);
	 virtual int create_image(int j, int w, int h,unsigned char huge *outdata);

private:
	 BITMAPFILEHEADER bmphdr;
	 IHEAD            pcthdr;
};

#endif
