#include <alloc.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include "imvwwin.h"
#define  SWAP(a,b) tempr=(a); (a)=(b); b=tempr
extern unsigned char huge *ThresData;
extern long number_of_bytes,start_point;
extern int im_width,im_height;
void Median_filter(int *Ridge_16,int number);
void Histogram();
void Mapping();
float *Data=NULL;
float huge *OutputR=NULL;
float huge *OutputI=NULL;
int huge * Ridge_Direction=NULL;
int * Ridge_16=NULL;
void DFTd1(int n,int isign);
void inverse_fft(float huge *TempOutR,float huge *TempOutI);

void SORT1(float *arr,int n);
void fft()
{
	  int i47;
	  float Fur,Fui;
	  float Spect;
	  long i,j,z=0;
	  long x,y;
	  Find_Direction(1);
	  if (OutputR != NULL || OutputI != NULL)
	  {
		  GlobalFreePtr(OutputR); GlobalFreePtr(OutputI);

	  }
	  if (Data!=NULL) GlobalFreePtr(Data);
	  Data=(float *) GlobalAllocPtr(GHND,2*(long)im_width*(long)8);
	  OutputR=(float huge*) GlobalAllocPtr(GHND,(long)im_width*(long)im_height*(long)4);
	  OutputI=(float huge*) GlobalAllocPtr(GHND,(long)im_width*(long)im_height*(long)4);

	  for (i=1;i<=im_width*2;i++)
	  {
		 Data[(int)i]= 0.0;
	  }
	  for (x=0; x<im_height; x++)
	  {
		 for (y=0; y<im_width; y++)
		 {
			 OutputR[x*im_width+y]=0.0;
			 OutputI[x*im_width+y]=0.0;
		 }
	  }
	  for (x=0;x<im_height;x++)
	  {
		 i47=0;
		 for (i=0;i<im_width;i++)
		 {
			 z=start_point+x*im_width+i;
			 if (z<=number_of_bytes)
			 {
				 i47++;
				 Data[i47]=(float)(ThresData[z]);
				 if (((x+i)/2)*2!=(x+i))  Data[i47]=-Data[i47];
				 i47++;
				 Data[i47]=0.0;
			 }
		 }
		 DFTd1(im_width,1);
		 i47=0;
		 for (j=0; j<im_height;j++)
		 {
			 i47++;
			 OutputR[x*im_width+j]=Data[i47]/im_width;
			 i47++;
			 OutputI[x*im_width+j]=Data[i47]/im_width;
		 }
	  } // end of x
	  for (y=0; y<im_height; y++)
	  {
		  i47=0;
		  for (i=0; i<im_width; i++)
		  {
			 i47++;
			 Data[i47]=OutputR[i*im_width+y];
			 i47++;
			 Data[i47]=OutputI[i*im_width+y];
		  }
		  DFTd1(im_width,1);
		  i47=0;
		  for (i=0; i<im_width; i++)
		  {
			 i47++;
			 OutputR[i*im_width+y]=Data[i47]/im_width;
			 i47++;
			 OutputI[i*im_width+y]=Data[i47]/im_width;
		  }
	  } // end of y
	  for (x=0; x<im_height; x++)
	  {
		  for (y=0; y<im_width; y++)
		  {
			  z=(long) (start_point+x*im_width+y);
			  if (z<=number_of_bytes)
			  {
				 if ( ((x+y)/2)*2!=(x+y) )  OutputR[x*im_width+y]=-OutputR[x*im_width+y];
				 Fur=OutputR[x*im_width+y]*im_width;
				 Fui=OutputI[x*im_width+y]*im_width;
				 Spect=sqrt(Fur*Fur+Fui*Fui);
				 *(ThresData+z)=(unsigned char)Spect;;
			  }
		  } // end of y
	  } // end of x
	  GlobalFreePtr(Data);

}
void ifft()
{
	 int i47;
	 float Fur;
	 float scale;
	 float min,max;
	 long i,j,z=0;
	 long x,y;
	 if (Data!=NULL) GlobalFreePtr(Data);
	 Data=(float *) GlobalAllocPtr(GHND,2*(long)im_width*(long)8);
	 for (x=0; x<im_height; x++)
	 {
		 i47=0;
		 for (i=0; i<im_width; i++)
		 {
			 i47++;
			 Data[i47]=OutputR[x*im_width+i];
			 if (((x+i)/2)*2!=(x+i))  Data[i47]=-Data[i47];
			 i47++;
			 Data[i47]=OutputI[x*im_width+i];
		 }
		 DFTd1(im_width,-1);
		 i47=0;
		 for (j=0; j<im_width; j++)
		 {
			i47++;
			OutputR[x*im_width+j]=Data[i47];
			i47++;
			OutputI[x*im_width+j]=Data[i47];
		 }
	 } // end of x-loop

	 for (y=0; y<im_height; y++)
	 {
		 i47=0;
		 for (i=0; i<im_width; i++)
		 {
			 i47++;
			 Data[i47]=OutputR[i*im_width+y];
			 i47++;
			 Data[i47]=OutputI[i*im_width+y];
		 }
		 DFTd1(im_width,-1);
		 i47=0;
		 for (i=0; i<im_width; i++)
		 {
			 i47++;
			 OutputR[i*im_width+y]=Data[i47];
			 i47++;
			 OutputI[i*im_width+y]=Data[i47];
		 }
	 } // end of y loop*/
	 min=32767.0; max=0.0;
	 for (x=0; x<im_height; x++)
	 {
		for (y=0; y<im_width; y++)
		{
			if ( ((x+y)/2)*2!=(x+y) )  OutputR[x*im_width+y]=-OutputR[x*im_width+y];
			Fur=OutputR[x*im_width+y];
			if (Fur <min) min=Fur;
			if (Fur >max) max=Fur;
		} // end of y
	 } // end of x
	 if (min==max) scale=1.0;
	 else scale=(max-min);
	 for (x=0;x<im_height;x++)
	 {
		for(y=0;y<im_width;y++)
		{
			z=x*im_width+y;
			OutputR[z]=(fabs(OutputR[z])-min)*255/scale;
		}
	 }
	 for (x=0; x<im_height; x++)
	 {
		 for (y=0; y<im_width; y++)
		 {
			 z=(long) (x*im_width+y);
			 if (z<=number_of_bytes)
			 {
				 //	if ( ((x+y)/2)*2!=(x+y) )  OutputR[m-start_point+x*im_width+y]=-OutputR[m-start_point+x*im_width+y];
				 Fur=OutputR[x*im_width+y];
				 ThresData[start_point+z]=(unsigned char)Fur;
			 }
		 } // end of y
	 } // end of x
	 GlobalFreePtr(Data);

}
void DFTd1(int nn,int isign)
{
	 int n,mmax,m,j,istep,i;
	 double wtemp,wr,wpr,wpi,wi,theta;
	 float tempr,tempi;
	 n=nn<<1;
	 j=1;
	 for (i=1;i<n;i+=2)
	 {
		if (j>i)
		{
		  SWAP(Data[j],Data[i]);
		  SWAP(Data[j+1],Data[i+1]);
		}
		m=n>>1;
		while (m>=2 && j>m)
		{
		  j-=m;
		  m>>=1;
		}
		j+=m;
	 }
	 mmax=2;
	 while (n>mmax)
	 {
		istep=mmax<<1;
		theta=isign*(6.28318530717959/mmax);
		wtemp=sin(0.5*theta);
		wpr=-2*wtemp*wtemp;
		wpi=sin(theta);
		wr=1.0;
		wi=0.0;
		for(m=1;m<mmax;m+=2)
		{
		  for(i=m;i<=n;i+=istep)
		  {
			 j=i+mmax;
			 tempr=wr*Data[j]-wi*Data[j+1];
			 tempi=wr*Data[j+1]+wi*Data[j];
			 Data[j]=Data[i]-tempr;
			 Data[j+1]=Data[i+1]-tempi;
			 Data[i]+=tempr;
			 Data[i+1]+=tempi;
		  }
		  wr=(wtemp=wr)*wpr-wi*wpi+wr;
		  wi=wi*wpr+wtemp*wpi+wi;
		}
		mmax=istep;
	 }
}

void Low_pass_fft()
{
	 long x,y,z;
	 int x0,y0;
	 double theta;
	 float PI=3.14159265359;
	 double deltax,deltay;
	 int k,m,n,number,i,j,u;
	 number=im_width/16;
	 number=number*number;
	 GlobalFreePtr(ThresData);
	 ThresData=(unsigned char huge *)(GlobalAllocPtr(GHND,number_of_bytes));
	 float huge *TempOutR=(float huge*) GlobalAllocPtr(GHND,(long)im_width*(long)im_height*(long)4);
	 float huge *TempOutI=(float huge*) GlobalAllocPtr(GHND,(long)im_width*(long)im_height*(long)4);

	 for (k=0;k<=4;k++)
	 {
		for (x=0;x<im_height;x++)
		{
		  for (y=0;y<im_width;y++)
		  {
			 TempOutR[x*(long)im_width+y]=(float)0.0;
			 TempOutI[x*(long)im_width+y]=(float)0.0;
		  }
		}
		for (x=im_height/2;x<im_height;x++)
		{
			x0=(int) x-im_height/2;
			for (y=im_width/2;y<im_width;y++)
			{
			  y0=(int) y-im_width/2;
			  deltax=(double) x0;
			  deltay=(double) y0;
			  if (deltax*deltax+deltay*deltay >49)
			  {
			  if (x0!=0 && y0!=0)
			  {
				 theta=PI/2-atan2(deltax,deltay);
				 if (fabs(theta-k*PI/8)<PI/8)
				 {
					z=x*(long)im_width+y;
					TempOutR[z]=OutputR[z];
					TempOutI[z]=OutputI[z];
					z=((long)im_height/2-(long)x0)*(long)im_width+(long)im_width/2-(long)y0;
					TempOutR[z]=OutputR[z];
					TempOutI[z]=OutputI[z];
					if (k==0 || k==4)
					{
						z=((long)im_height/2-(long)x0)*(long)im_width+(long)y;
						TempOutR[z]=OutputR[z]*1.0;
						TempOutI[z]=OutputI[z]*1.0;
						z=x*(long)im_width+(long)im_width/2-(long)y0;
						TempOutR[z]=OutputR[z]*1.0;
						TempOutI[z]=OutputI[z]*1.0;
					}



				 }

			  }
			  }


			}
		}
		inverse_fft(TempOutR,TempOutI);
		for (i=0;i<32;i++)
		{
		  for (j=0;j<32;j++)
		  {
			  u=i*32+j;
			  if (Ridge_16[u]==k)
			  {
				 for (m=0;m<16;m++)
				 {
					for (n=0;n<16;n++)
					{
						z=(long)(i*16+m)*(long) im_width+ (long) (j*16+n);
						if (ThresData[z]==0)
							ThresData[z]=(unsigned char) (TempOutR[z]);

					}
				 }
			  }
		  }
		}
	 }
	 for (k=5;k<=7;k++)
	 {
		for (x=0;x<im_height;x++)
		{
		  for (y=0;y<im_width;y++)
		  {
			 TempOutR[x*(long)im_width+y]=(float)0.0;
			 TempOutI[x*(long)im_width+y]=(float)0.0;
		  }
		}
		for (x=0;x<im_height;x++)
		{
		  for (y=0;y<im_width;y++)
		  {
			 TempOutR[x*(long)im_width+y]=(float)0.0;
			 TempOutI[x*(long)im_width+y]=(float)0.0;
		  }
		}
		for (x=im_height/2;x<im_height;x++)
		{
			x0=(int) x-im_height/2;
			deltax=(double) x0;
			for (y=0;y<im_width/2;y++)
			{
			  y0=(int) y-im_width/2+1;
			  deltay=(double) (abs(y0));
			  if (deltax*deltax+deltay*deltay >49)
			  {
			  if (x0!=0 && y0!=0)
			  {
				 theta=PI-atan2(deltax,deltay);
				 if (fabs(theta-k*PI/8)<PI/8)
				 {

					z=x*im_width+y;
					TempOutR[z]=OutputR[z];
					TempOutI[z]=OutputI[z];
					z=((long)im_height/2-(long)x0)*(long)im_width+(long)im_width/2+(long)abs(y0);
					TempOutR[z]=OutputR[z];
					TempOutI[z]=OutputI[z];
				 }
			  }
			  }
			}

		}
		inverse_fft(TempOutR,TempOutI);
		for (i=0;i<32;i++)
		{
		  for (j=0;j<32;j++)
		  {
			 u=i*32+j;
			 if (Ridge_16[u]==k)
			 {
				for (m=0;m<16;m++)
				{
				  for (n=0;n<16;n++)
				  {
					 z=(long)(i*16+m)*(long) im_width+ (long) (j*16+n);
					 if (ThresData[z]==0)
						 ThresData[z]=(unsigned char) (TempOutR[z]);


				  }
				}
			 }
		  }
		}
	 }
	 for (i=0;i<32;i++)
	  {
		 for (j=0;j<512;j++)
		 {
			 z=i*(long)im_width+j;
			 ThresData[z]=0;
			 z=j*(long)im_width+i;
			 ThresData[z]=0;
			 z=(511-i)*(long)im_width+j;
			 ThresData[z]=0;
			 z=j*(long)im_width+(511-i);
			 ThresData[z]=0;
		 }
	  }
	 GlobalFreePtr(TempOutR);
	 GlobalFreePtr(TempOutI);
}

void inverse_fft(float huge *TempOutR, float huge *TempOutI)
{
	 int i47;
	 long i,j;
	 long x,y,z;
	 if (Data!=NULL) GlobalFreePtr(Data);
	 Data=(float *) GlobalAllocPtr(GHND,2*(long)im_width*(long)8);
	 for (x=0; x<im_height; x++)
	 {
		 i47=0;
		 for (i=0; i<im_width; i++)
		 {
			 i47++;
			 Data[i47]=TempOutR[x*im_width+i];
			 if (((x+i)/2)*2!=(x+i))  Data[i47]=-Data[i47];
			 i47++;
			 Data[i47]=TempOutI[x*im_width+i];
		 }
		 DFTd1(im_width,-1);
		 i47=0;
		 for (j=0; j<im_width; j++)
		 {
			i47++;
			TempOutR[x*im_width+j]=Data[i47];
			i47++;
			TempOutI[x*im_width+j]=Data[i47];
		 }
	 } // end of x-loop

	 for (y=0; y<im_height; y++)
	 {
		 i47=0;
		 for (i=0; i<im_width; i++)
		 {
			 i47++;
			 Data[i47]=TempOutR[i*im_width+y];
			 i47++;
			 Data[i47]=TempOutI[i*im_width+y];
		 }
		 DFTd1(im_width,-1);
		 i47=0;
		 for (i=0; i<im_width; i++)
		 {
			 i47++;
			 TempOutR[i*im_width+y]=Data[i47];
			 i47++;
			 TempOutI[i*im_width+y]=Data[i47];
		 }
	 } // end of y loop*/

	 for (x=0;x<im_height;x++)
	 {
		for(y=0;y<im_width;y++)
		{

			z=x*(long)im_width+y;
			if ( ((x+y)/2)*2!=(x+y) )  TempOutR[z]=-TempOutR[z];
			if (TempOutR[z]<=0.0) TempOutR[z]=0.0;
			else
			  if (TempOutR[z]>0 && TempOutR[z]<200) TempOutR[z]=TempOutR[z]+55.0;



		}
	 }
	 GlobalFreePtr(Data);
	 return;
}
void Find_Direction(int def)
{
	  Ridge_Direction=(int huge *) GlobalAllocPtr(GHND,number_of_bytes*(long)2);
	  long x,y,z,u,v;
	  long start,end,m;
	  long i,j,t;
	  int min,d,i1,number;
	  int *Ridge=(int*)GlobalAllocPtr(GHND,16);
	  for (x=0;x<512;x++)
	  {
		 for (y=0;y<512;y++)
		 {
			for (i1=0;i1<8;i1++) Ridge[i1]=0;
			u=start_point+x*(long)im_width+y;
			for (i=y+1;i<=y+10;i++)
			{
			  if(i<512)
			  {
				 z=start_point+x*(long)im_width+i;
				 Ridge[0]=Ridge[0]+abs((int)ThresData[u]-(int)ThresData[z]);
			  }
			  else Ridge[0]=32767;
			}
			v=0;
			for (j=1;j<=3;j++)
			{
			  for(i=1;i<=3;i++)
			  {
				 v++;
				 if (y+v <511 && x+j<511)
				 {
					z=start_point+(x+j)*(long)im_width+y+v;
					Ridge[5]=Ridge[5]+abs((int)ThresData[u]-(int)ThresData[z]);
				 }
				 else Ridge[5]=30000;
			  }
			}
			v++;
			z=start_point+(x+j)*(long)im_width+y+v;
			if (z<number_of_bytes)
				 Ridge[5]=Ridge[5]+abs((int)ThresData[u]-(int)ThresData[z]);
			for (i=1;i<=10;i++)
			{
				if(x+i<512 && y+i<512)
				{
				  z=start_point+(i+x)*(long)im_width+y+i;
				  Ridge[6]=Ridge[6]+abs((int)ThresData[u]-(int)ThresData[z]);
				}
				else Ridge[6]=32766;
			}
			v=0;
			for (j=1;j<=3;j++)
			{
			  for (i=1;i<=3;i++)
			  {
				 v++;
				 if (x+v<511 && y+j<511)
				 {
					z=start_point+(x+v)*(long)im_width+y+j;
					Ridge[7]=Ridge[7]+abs((int)ThresData[u]-(int)ThresData[z]);
				 }
				 else Ridge[7]=30000;
			  }
			}
			v++;
			z=start_point+(v+x)*(long)im_width+y+j;
			if (z<number_of_bytes)
					Ridge[7]=Ridge[7]+abs((int)ThresData[u]-(int)ThresData[z]);
			for (i=x+1;i<=x+10;i++)
			{
				if (i<512)
				{
				  z=start_point+i*(long)im_width+y;
				  Ridge[4]=Ridge[4]+abs((int)ThresData[u]-(int)ThresData[z]);
				}
				else Ridge[4]=32766;
			}
			v=0;
			for (i=1;i<=3;i++)
			{
			  for (j=1;j<=3;j++)
			  {
				 v++;
				 if (x+v <511 && y-i>0)
				 {
					z=start_point+(x+v)*(long)im_width+y-i;
					Ridge[3]=Ridge[3]+abs((int)ThresData[u]-(int)ThresData[z]);
				 }
				 else Ridge[3]=30000;
			  }
			}
			v++;
			z=start_point+(x+v)*(long)im_width+y-i;
			if (z<number_of_bytes)
				  Ridge[3]=Ridge[3]+abs((int)ThresData[u]-(int)ThresData[z]);
			for (i=1;i<=10;i++)
			{
				if (x+i<512 && y-i>=0)
				{
					z=start_point+(i+x)*(long)im_width+y-i;
					Ridge[2]=Ridge[2]+abs((int)ThresData[u]-(int)ThresData[z]);
				}
				else Ridge[2]=32766;
			}
			v=0;
			for (j=1;j<=3;j++)
			{
			  for(i=1;i<=3;i++)
			  {
				 v++;
				 if (x+j<511 && y-v>0)
				 {
					 z=start_point+(x+j)*(long)im_width+y-v;
					 Ridge[1]=Ridge[1]+abs((int)ThresData[u]-(int)ThresData[z]);
				 }
				 else Ridge[1]=30000;
			  }
			}
			v++;
			z=start_point+(x+j)*(long)im_width+y-v;
			if (z<number_of_bytes)
				  Ridge[1]=Ridge[1]+abs((int)ThresData[u]-(int)ThresData[z]);
			min=Ridge[0];d=0;
			for (i1=1;i1<=7;i1++)
			{
				if (Ridge[i1]<min)
				{
					min=Ridge[i1];
					d=i1;
				}
			}

			Ridge_Direction[u-start_point]=d;
			if (def==0) ThresData[u]=(unsigned char)(d*25);
		 }
	  }
	  if (def==0) return;
	  Histogram();
	  number=0;
	  if (def==2)
	  {
		 for (t=0; t<(im_height/16); t++)
		 {
			start=(long)16*(long)im_width*(long)t;
			end=(long)16*(long)im_width*t+(long)(im_width-1);
			for (m=start;m<end;m=m+16)
			{
			  for (i=0; i<16;i++)
			  {
				 for (j=0; j<16;j++)
				 {
					z=start_point+m+i*(long)im_width+j;
					ThresData[z]=(unsigned char) (Ridge_16[number]*25);
				 }
			  }
			  number++;
			}
		 }

	  }
	  if (def==3)
	  {
		  Mapping();
	  }
	  return;

}
void Histogram()
{
	  int t,i,max,direc,number;
	  long m,l,k,z;
	  long start,end;
	  int *Hist=(int *)GlobalAllocPtr(GHND,16);
	  Ridge_16=(int *)GlobalAllocPtr(GHND,1024*2);
	  number=0;
	  for (t=0; t<(im_height/16); t++)
	  {
		  start=(long)16*(long)im_width*(long)t;
		  end=(long)16*(long)im_width*t+(long)(im_width-1);
		  for (m=start;m<end;m=m+16)
		  {
			  for (i=0;i<8;i++) Hist[i]=0;
			  for (k=0; k<16;k++)
			  {
				 for (l=0; l<16;l++)
				 {
					z=m+l*(long)im_width+k;
					Hist[Ridge_Direction[z]]+=1;
				 }
			  }
			  max=Hist[0];direc=0;

			  for (i=1;i<8;i++)
			  {
				  if (Hist[i]>max)
				  {
					  max=Hist[i];
					  direc=i;
				  }
			  }
			  if (t>=26)
					int o=0;
			  Ridge_16[number]=direc;
			  number++;
		  }

	  }
	 
	  Median_filter(Ridge_16,im_width/16);
	  return;
}
void Median_filter(int *Ridge_16,int number)
{
	 int i,j,k,z,l;
	 int *Temp=(int *)GlobalAllocPtr(GHND, number*number*2);
	 float *Order=(float *) GlobalAllocPtr(GHND,3*3*4);
	 int m;
	 for (i=1;i<number-1;i++)
	 {
		for (j=1;j<number-1;j++)
		{
			m=0;
			for (k=i-1;k<i+1+1;k++)
			{
			  for (l=j-1;l<j+1+1;l++)
			  {
				 m++;
				 z=k*number+l;
				 Order[m]=(float) Ridge_16[z];
			  }
			}
			SORT1(Order,9);
			z=i*number+j;
			Temp[z]=(unsigned char) Order[5];

		}
	 }
	 for (i=1;i<number-1;i++)
	 {
		for(j=1;j<number-1;j++)
		{
		  z=i*number+j;
		  Ridge_16[z]=Temp[z];
		}
	 }

	 GlobalFreePtr(Temp);
	 GlobalFreePtr(Order);
	 return;
}

void SORT1(float *arr,int n)
{
	int i,j;
	float a;
	for (i=1;i<=n;i++)
	{
	  a=arr[i];
	}
	for (j=2;j<=n;j++)
	{
	  a=arr[j];
	  i=j-1;
	  while (i>0 && arr[i] >a)
	  {
		 arr[i+1]=arr[i];
		 i--;
	  }
	  arr[i+1]=a;
	}
	for (i=1;i<=n;i++)
	{
	  a=arr[i];
	}
	return;
}
void Mapping()
{
	long start,end,i,j,m,v,z;
	int number=0,t;
	long x,y;
	for (t=0; t<(im_height/16); t++)
	{
		start=(long)16*(long)im_width*(long)t;
		end=(long)16*(long)im_width*t+(long)(im_width-1);
		x=(long)t*(long)16;
		for (m=start,y=0;m<end;m=m+16,y=y+16)
		{
		  if (Ridge_16[number]==0)
		  {
			 for (i=y+1;i<=y+13;i++)
			 {
				if(i<512)
				{
				  z=start_point+(x+8)*(long)im_width+i+3;
				  ThresData[z+512]=ThresData[z]=(unsigned char) 255;
				}
			 }
		  }
		  if (Ridge_16[number]==5)
		  {
			 v=0;
			 for (j=1;j<=4;j++)
			 {
				for(i=1;i<=3;i++)
				{
				  v++;
				  if (y+v+3 <511 && x+j+4<511)
				  {
					 z=start_point+(x+j+4)*(long)im_width+y+v+3;
					 ThresData[z+512]=ThresData[z]=(unsigned char) 255;
				  }
				}
			 }
			 v++;
			 z=start_point+(x+j+4)*(long)im_width+y+v+3;
			 if (z<number_of_bytes)
				 ThresData[z+512]=ThresData[z]=(unsigned char) 255;
		  }
		  if (Ridge_16[number]==6)
		  {
			 for (i=1;i<=13;i++)
			 {
				if(x+i+3<512 && y+i+3<512)
				{
				  z=start_point+(i+x+3)*(long)im_width+y+i+3;
				  ThresData[z+512]=ThresData[z]=(unsigned char) 255;
				}
			 }
		  }
		  if (Ridge_16[number]==7)
		  {
			 v=0;
			 for (j=1;j<=3;j++)
			 {
				for (i=1;i<=4;i++)
				{
				  v++;
				  if (x+v+3<511 && y+j+7<511)
				  {
					 z=start_point+(x+v+3)*(long)im_width+y+j+7;
					 ThresData[z+1]=ThresData[z]=(unsigned char) 255;
				  }
				}
			 }
			 v++;
			 z=start_point+(v+x+3)*(long)im_width+y+j+7;
			 if (z<number_of_bytes)
				ThresData[z+1]=ThresData[z]=(unsigned char) 255;
		  }
		  if (Ridge_16[number]==4)
		  {
			 for (i=x+1;i<=x+13;i++)
			 {
				if (i<512)
				{
				  z=start_point+(i+3)*(long)im_width+y+8;
				  ThresData[z+1]=ThresData[z]=(unsigned char) 255;
				}
			 }
		  }
		  if (Ridge_16[number]==3)
		  {
			 v=0;
			 for (i=1;i<=3;i++)
			 {
				for (j=1;j<=4;j++)
				{
				  v++;
				  if (x+v+3 <511 && y-i+7>0)
				  {
					 z=start_point+(x+v+3)*(long)im_width+y+7-i;
					 ThresData[z+1]=ThresData[z]=(unsigned char) 255;
				  }
				}
			 }
			 v++;
			 z=start_point+(x+v+3)*(long)im_width+y+7-i;
			 if (z<number_of_bytes)
				  ThresData[z+1]=ThresData[z]=(unsigned char) 255;
		  }
		  if (Ridge_16[number]==2)
		  {
			 for (i=1;i<=13;i++)
			 {
				if (x+i<512 && y-i>=0)
				{
					z=start_point+(i+x+3)*(long)im_width+y-i+9;
					ThresData[z+512]=ThresData[z]=(unsigned char) 255;
				}
			 }
		  }
		  if (Ridge_16[number]==1)
		  {
			 v=0;
			 for (j=1;j<=4;j++)
			 {
				for(i=1;i<=3;i++)
				{
				  v++;
				  if (x+j+7<511 && y-v+13>0)
				  {
					 z=start_point+(x+j+7)*(long)im_width+y-v+13;
					 ThresData[z+512]=ThresData[z]=(unsigned char) 255;
				  }
				}
			 }
			 v++;
			 z=start_point+(x+j+7)*(long)im_width+y-v+13;
			 if (z<number_of_bytes)
				  ThresData[z+512]=ThresData[z]=(unsigned char) 255;
		  }
		  number++;
		}
	}
	return;
}
