//---------------------------------------------------------------
//  File:  imagevw.cpp
//
//  A Windows application for viewing images in a variety of
//  formats such as Windows bitmap (.BMP), PC PaintBrush (.PCX),
//  and Targa (.TGA) , Graphics Interchange Format (.GIF), and
//  the Tagged Image File Format (.TIF).
//---------------------------------------------------------------
#include <owl\applicat.h>
#include <stdio.h>
#include "imvwwin.h"
// unsigned char huge *ThresData=NULL;
unsigned char huge *SepareThresData=NULL;
int im_width,im_height;
BOOL Threscheck;
char checkname[80];
long bfOffBits=0,bfSize=0,number_of_bytes=0,start_point=0;
class ImageViewApp: public TApplication
{
public:
// Constructor that simply calls the base class constructor

	 ImageViewApp(const char far *name) : TApplication(name) {}

// Define function to initialize application's main window
	 void InitMainWindow();
};
//---------------------------------------------------------------
//  I m a g e V i e w A p p : : I n i t M a i n W i n d o w

void ImageViewApp::InitMainWindow()
{
	 MainWindow = new TMDIFrame("Fingerprint Recognition System", "MainMenu",
										*new ImageViewFrame);

// Assign icon for the application
	 MainWindow->SetIcon(this, "IMAGEVIEWAPP_ICON");
	 MainWindow->AssignMenu("MainMenu");
	 MainWindow->Attr.AccelTable = "MainAccelTable";

	 EnableBWCC();
	 EnableCtl3d();
}
//---------------------------------------------------------------
//  O w l M a i n
//
//  Create an instance of the application and "run" it.

int OwlMain(int, char**)
{
	 ImageViewApp ImageView("Fingerprint Recognition System");
	 return ImageView.Run();
}
