#include <alloc.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include "imvwwin.h"
extern unsigned char huge *ThresData;
extern long number_of_bytes,start_point;
extern int im_width,im_height;
extern int ThresLevel;
extern int StrengthLevel;
void SORT(float *arr,int n);
extern int *Ridge_16;
int perform(unsigned char huge* Temp,long x, long y);
int perform1(unsigned char huge* Temp,long x, long y);
int perform2(unsigned char huge* Temp,long x, long y);
int perform_ridge(unsigned char huge* Temp,long x, long y);
void Delete();
void Delete_bif1();
void Connect();
void Delete_bifurcation(long v);
void Threshold_Level(unsigned char huge *ThresData)
{

		for (long i=start_point; i < number_of_bytes; i++)
		{
			if (*(ThresData+i) < ThresLevel) *(ThresData+i)=0; else *(ThresData+i)=255;
		}
		return;
}
void Window(unsigned char huge *ThresData, int mask_number1, int mask_number2)
{
	  long i,j,z;

	  for (i=0;i<32;i++)
	  {
		 for (j=0;j<512;j++)
		 {
			 z=start_point+i*(long)im_width+j;
			 ThresData[z]=0;
			 z=start_point+j*(long)im_width+i;
			 ThresData[z]=0;
			 z=start_point+(511-i)*(long)im_width+j;
			 ThresData[z]=0;
			 z=start_point+j*(long)im_width+(511-i);
			 ThresData[z]=0;
		 }
	  }
	  int t,k,l,k17,number=0,Thres_level;
	  long Total=0;
	  long m=0;
	  k17=mask_number2;
	  if (mask_number1 !=4)
	  {
		 for (t=0; t<(im_height/mask_number1); t++)
		 {
			 for (m= (long) start_point+ (long)mask_number1*im_width*t ; m < (long)start_point+ (long)mask_number1*im_width*t+(long) (im_width-1) ;m=m+k17)
			 {
				 for (k=0; k<mask_number1;k++)
				 {
					for (l=0; l<mask_number1;l++)
					{
						z=(long) (m+l*im_width+k);
						Total=Total+(long)*(ThresData+z);
					}
				 }
				 Thres_level=(int) (Total/((long)mask_number1*(long)mask_number1));
				 if (Thres_level > 150 ) Thres_level=150;
				 number++;
				 if (number == (im_width/mask_number1)) { k17=mask_number1; number=0; }
				 else k17=mask_number2;
				 for (k=0; k<k17;k++)
				 {
					 for (l=0; l<mask_number1;l++)
					 {
						 z=(long) (m+l*im_width+k);
						 if (*(ThresData+z) < Thres_level) *(ThresData+z)=0;
						 else *(ThresData+z)=255;
					 }
				 }
				 Total=0;
			 }
		 }
	  }
	  else
	  {
		 long i,j,z;
		 for (i=0;i<im_height;i=i+16)
		 {
		  for(j=0;j<im_width;j++)
		  {
			 z=start_point+i*im_width+j;
			 ThresData[z]=128;
		  }
		 }
		 for (i=0;i<im_height;i++)
		 {
		  for(j=0;j<im_width;j=j+16)
		  {
			 z=start_point+i*im_width+j;
			 ThresData[z]=128;
		  }
		 }
	  }
	  return;
}
void Rotate()
{
	 long i,j,k,l;
	 unsigned char huge *ThinData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);

	 for (i=0; i<512; i++)
	 {
		 k=start_point+i*512; // for new image
		 for(j=0; j<512; j++)
		 {
			  l=start_point+(512-1-j)*512+i;
			  *(ThinData+k+j)=*(ThresData+l);
			  k=start_point+i*Thres_width+j;
			  l=start_point+(Thres_width-i)*Thres_width+j-512;
			  *(ThinData+l)=*(ThresData+k);

		 }
	 }
	 for(l=start_point;l<number_of_bytes;l++)  *(ThresData+l)=*(ThinData+l);
	 GlobalFreePtr(ThinData);


}
void Scaling()
{
	long i1,j1,u;
	float scale=0;
	float min,max;
	min=255; max=0;
	for (i1=0;i1<512;i1++)
	{
	  for (j1=0;j1<512;j1++)
	  {
		 u=start_point+(long) im_width*i1+j1;
		 if (ThresData[u]<min) min=(float) ThresData[u];
		 if (ThresData[u]>max) max=(float) ThresData[u];
	  }
	}

	if (min==max) scale=1.0;
	else scale=max-min;

	for (i1=0;i1<im_height;i1++)
	{
	  for(j1=0;j1<im_width;j1++)
	  {
			u=start_point+i1*im_width+j1;
			ThresData[u]=(char) (fabs((float) ThresData[u])-(float)min)*255/scale;
	  }
	}

	return;

}


void Equalization()
{
	 long i,j,z;
	 int k,m;
	 int minval,minj;
	 int val;
	 int *IHIST = (int *)malloc(512);
	 int *HISTEQ = (int *)malloc(512);
	 float Sum=0.0;
	 float *HIST=(float*)malloc(1024);
	 float *SPEC=(float*)malloc(1024);
	 for (k=0;k<64;k++)
	 {
		 SPEC[k]=0.0; SPEC[k+192]=0.0;
	 }
	 for (k=64;k<=128;k++)
	 {
		  SPEC[k]=(float) 0.02 * (float) (k-63)/(float) 64;
		  SPEC[256-k]=SPEC[k];
	 }

	

	 for (k=0;k<256;k++) IHIST[k]=0;
	 for (i=0;i<512;i++)
	 {
		for (j=0;j<512;j++)
		{
		  z=(long) start_point+(long)i*(long)im_width+(long)j;
		  val=(int)ThresData[z];
		  IHIST[val]+=1;
		}
	 }
	 for (k=0;k<256;k++) HIST[k]=(float)IHIST[k]/(float)262144;

	 for (k=0;k<256;k++)
	 {
		 Sum=Sum+HIST[k];
		 HISTEQ[k]=(int) (255.0 * Sum + 0.5);

	 }
	 for (i=0;i<512;i++)
	 {
		for (j=0;j<512;j++)
		{
		  z=(long) start_point+(long)i*(long)im_width+(long)j;
		  val=(int)ThresData[z];
		  ThresData[z]=(char) HISTEQ[val];
		}
	 }
	 Sum=0.0;
	 for (k=0;k<256;k++) HISTEQ[k]=0.0;
	 for (k=0;k<256;k++)
	 {
		 Sum=Sum+SPEC[k];
		 HISTEQ[k]=(int) (255.0 * Sum + 0.5);
	 }
	 for (k=0;k<256;k++)
	 {
		minval=abs(k-HISTEQ[0]); minj=0;
		for (m=0;m<256;m++)
		{
			 if (abs(k-HISTEQ[m]) <minval)
			 {
				  minval=abs(k-HISTEQ[m]);
				  minj=m;
			 }
		}
		IHIST[k]=minj;
	 }
	 for (i=0;i<512;i++)
	 {
		for (j=0;j<512;j++)
		{
		  z=(long) start_point+(long)i*(long)im_width+(long)j;
		  ThresData[z]=(char) IHIST[(int)ThresData[z]];
		}
	 }
	 free(IHIST);
	 free(HISTEQ);
	 free(HIST);
	 free(SPEC);
	 return;



}
void Median(int Mask_Med)
{
	 long i,j,k,l,z;
	 unsigned char huge *ThinData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
	 float *Order=(float *) GlobalAllocPtr(GHND,Mask_Med*Mask_Med*4);
	 int start,m=0;
	 if (Mask_Med==5) start=2;
	 else start=1;
	 for (i=start;i<im_height-start;i++)
	 {
		for (j=start;j<im_width-start;j++)
		{
			m=0;
			for (k=i-start;k<i+start+1;k++)
			{
			  for (l=j-start;l<j+start+1;l++)
			  {
				 m++;
				 z=start_point+k*im_width+l;
				 Order[m]=(float) ThresData[z];
			  }
			}
			SORT (Order,Mask_Med*Mask_Med);
			ThinData[start_point+i*im_width+j]=(unsigned char) Order[Mask_Med*Mask_Med/2+1];

		}
	 }

	// for(l=start_point;l<number_of_bytes;l++)  *(ThresData+l)=*(ThinData+l);
	 for (i=1;i<511;i++)
	 {
		for (j=1;j<511;j++)
		{
		  z=start_point+(long) im_width*i+j;
		  ThresData[z]=ThinData[z];
		  //ThresData[z]=(char) ((int) ThresData[z]-(int) ThinData[z]);
		}
	 }
	 GlobalFreePtr(ThinData);
}
void Mean_filter(int Mask_mean)
{
	 long i,j,k,l,z;
	 unsigned char huge *ThinData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
	 long Sum;
	 int start;
	 if (Mask_mean==5) start=2;
	 else start=1;
	 for (i=start;i<im_height-start;i++)
	 {
		for (j=start;j<im_width-start;j++)
		{
			Sum=0;
			for (k=i-start;k<i+start+1;k++)
			{
			  for (l=j-start;l<j+start+1;l++)
			  {
				 z=start_point+k*im_width+l;
				 Sum=Sum+(long) *(ThresData+z);
			  }
			}
			z=start_point+i*im_width+j;
			ThinData[start_point+i*im_width+j]=(unsigned char) (Sum/((long)Mask_mean*(long) Mask_mean));

		}
	 }

	 //for(l=start_point;l<number_of_bytes;l++)  *(ThresData+l)=*(ThinData+l);
	 for (i=1;i<511;i++)
	 {
		for (j=1;j<511;j++)
		{
		  z=start_point+(long) im_width*i+j;
			 // ThresData[z]=(char) ((int) ThresData[z]-(int) ThinData[z]);
		  ThresData[z]=ThinData[z];
		}
	 }
	 GlobalFreePtr(ThinData);

}
void Ridge_Thin()
{
	long i,j,z,l;
	long xpos,ypos,w,x;
	int k,end_while,number;
	FILE *fp;
	
	unsigned char huge *T=(unsigned char huge *)GlobalAllocPtr(GHND,number_of_bytes);

	w=(long)im_width;
	for (i=0;i<512;i++)
	{
	  for (j=0;j<512;j++)
	  {
		 z=start_point+i*(long)512+j;
		 if (ThresData[z]==0)
		 {
			xpos=i;ypos=j;
			end_while=1;
			while (end_while==1)
			{
			  end_while=0;
			  k=(int)(xpos/16)*32+(int)ypos/16;
			  if (Ridge_16[k]==0 || Ridge_16[k]==5 || Ridge_16[k]==1)
			  {
				  number=0;
				  z=start_point+(xpos+1)*w+ypos;
				  if (ThresData[z]==0)
				  {
					 for (l=xpos;l<w;l++)
					 {
						z=start_point+l*w+ypos;
						if (ThresData[z]!=255)
						{
						  ThresData[z]=128;
						  number++;
						}
						else l=w;
					 }
				  number=(int) ((number+1)/2);

				  for (l=xpos+number;l<=xpos+number+4;l++)
				  {
					 if (perform(T,l,ypos)==1)
					 {
						for (x=l;x>=xpos+number;x--)
						{
						  z=start_point+x*w+ ypos;
						  T[z]=255;
						}
						l=w;
					 }
				  }
				  for (l=xpos+number;l>=xpos+number-4;l--)
				  {
					 if (perform(T,l,ypos)==1)
					 {
						for (x=l;x<=xpos+number;x++)
						{
						  z=start_point+x*w+ ypos;
						  T[z]=255;
						}
						l=-1;
					 }
				  }
				  z=start_point+(xpos+number)*w+ypos;
				  T[z]=255;
				  z=start_point+(xpos-1)*w+ypos;
				  if (ThresData[z]==0 && perform(ThresData,xpos-1,ypos)==1)
				  {
					 xpos=xpos-1;
					 end_while=1;
				  }
				  if (end_while==0)
				  {
					 for (l=-1;l<=1;l++)
					 {
						z=start_point+(xpos+l)*w+ypos-1;
						if (ThresData[z]==0 && perform(ThresData,xpos+l,ypos-1)==1)
						{
							xpos=xpos+l;
							ypos=ypos-1;
							l=2;
							end_while=1;
						}
					 }
				  }
				  if (end_while==0)
				  {
					 z=start_point+(xpos+1)*w+ypos;
					 if (ThresData[z]==0 && perform(ThresData,xpos+1,ypos)==1)
					 {
						 xpos=xpos+1;
						 end_while=1;
					 }
				  }
				  if (end_while==0)
				  {
					  for (l=1;l>=0;l--)
					  {
						 z=start_point+(xpos+l)*w+ypos+1;
						 if (ThresData[z]==0 && perform(ThresData,xpos+l,ypos+1)==1)
						 {
							xpos=xpos+l;
							ypos=ypos+1;
							l=-1;
							end_while=1;
						 }
					  }
				  }
				  }
				  else end_while=0;

			  }
			  else
			  {
				  number=0;
				  z=start_point+xpos*w+ypos+1;
				  if (ThresData[z]==0)
				  {
					 for (l=ypos;l<w;l++)
					 {
						z=start_point+xpos*w+l;
						if (ThresData[z]!=255)
						{
						  ThresData[z]=128;
						  number++;
						}
						else l=w;
					 }

				  number=(int) ((number+1)/2);
				  for (l=ypos+number;l<=ypos+number+4;l++)
				  {
					 if (perform(T,xpos,l)==1)
					 {
						for (x=l;x>=ypos+number;x--)
						{
						  z=start_point+xpos*w+ x;
						  T[z]=255;
						}
						l=w;
					 }
				  }
				  for (l=ypos+number;l>=ypos+number-4;l--)
				  {
					 if (perform(T,xpos,l)==1)
					 {
						for (x=l;x<=ypos+number;x++)
						{
						  z=start_point+xpos*w+x;
						  T[z]=255;
						}
						l=-1;
					 }
				  }
				  z=start_point+xpos*w+ypos+number;
				  T[z]=255;
				  z=start_point+(xpos-1)*w+ypos;
				  if (ThresData[z]==0 && perform(ThresData,xpos-1,ypos)==1)
				  {
					 xpos=xpos-1;
					 end_while=1;
				  }
				  if (end_while==0)
				  {
					 for (l=-1;l<=1;l++)
					 {
						z=start_point+(xpos+l)*w+ypos-1;
						if (ThresData[z]==0 && perform(ThresData,xpos+l,ypos-1)==1)
						{
							xpos=xpos+l;
							ypos=ypos-1;
							if (l==1)
							{
							  for (x=ypos-1;x>=0;x--)
							  {
								 z=start_point+xpos*w+x;
								 if (ThresData[z]==0)
									  ypos=x;
								 else x=-1;
							  }
							}
							l=2;
							end_while=1;
						}
					 }
				  }
				  if (end_while==0)
				  {
					 z=start_point+(xpos+1)*w+ypos;
					 if (ThresData[z]==0 && perform(ThresData,xpos+1,ypos)==1)
					 {
						 xpos=xpos+1;
						 end_while=1;
					 }
				  }
				  if (end_while==0)
				  {
					  for (l=1;l>=1;l--)
					  {
						 z=start_point+(xpos+l)*w+ypos+1;
						 if (ThresData[z]==0 && perform(ThresData,xpos+l,ypos+1)==1)
						 {
							xpos=xpos+l;
							ypos=ypos+1;
							l=-1;
							end_while=1;
						 }
					  }
				  }
				  }else end_while=0;
			  }

			}
		 }
	  }
	}

	for (i=0;i<w;i++)
	{
	  for (j=0;j<w;j++)
	  {
		 z=start_point+i*w+j;
		 if (T[z]==255)
		 {
			 T[z]=ThresData[z]=0;
		 }
		 else ThresData[z]=255;
	  }
	}
	Delete();
	Delete_bif1();
	Delete();
	Connect();
	Delete();
	Delete_bif1();
	Delete();

	GlobalFreePtr(T);


}

int perform(unsigned char huge *Temp, long x, long y)
{
	int m,n;
	long v;
	for (m=-1;m<=1;m++)
	{
	  for(n=-1;n<=1;n++)
	  {
		 v=start_point+(x+m)*(long)(im_width)+y+n;
		 if (Temp[v]==255) return 1;
	  }
	}
	return 0;
}
int perform1(unsigned char huge *Temp, long x, long y)
{
	int m,n;
	long v;
	for (m=-1;m<=1;m++)
	{
	  for(n=-1;n<=1;n++)
	  {
		 v=start_point+(x+m)*(long)(im_width)+y+n;
		 if (Temp[v]==0) return 0;
	  }
	}
	return 1;
}
int perform2(unsigned char huge *Temp, long x, long y)
{
	int m,n;
	long v;
	for (m=-1;m<=1;m++)
	{
	  for(n=-1;n<=1;n++)
	  {
		 v=start_point+(x+m)*(long)(im_width)+y+n;
		 if (Temp[v]==150) return 1;
	  }
	}
	return 0;
}

int perform_ridge(unsigned char huge *Temp, long x, long y)
{
	int m,n,number;
	long v;
	number=0;
	for (m=-1;m<=1;m++)
	{
	  for(n=-1;n<=1;n++)
	  {
		 v=start_point+(x+m)*(long)(im_width)+y+n;
		 if (Temp[v]==0) number++;
	  }
	}
	return number;
	
}

void Thin_Morf(int start_row,int start_col)
{
	int B[9][3][3];
	unsigned long o1,o2,o4,o5,z;
	int flag, change, Global,t1,t2,g;
	unsigned char	uch1;
	unsigned char huge *ThinData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);

	B[1][0][0]=0;		B[1][0][1]=0;		B[1][0][2]=0;
	B[1][1][0]=2;		B[1][1][1]=1;		B[1][1][2]=2;
	B[1][2][0]=1;		B[1][2][1]=1;		B[1][2][2]=1;
	//------------------------------B[1] ---------------
	B[2][0][0]=2;		B[2][0][1]=0;		B[2][0][2]=0;
	B[2][1][0]=1;		B[2][1][1]=1;		B[2][1][2]=0;
	B[2][2][0]=1;		B[2][2][1]=1;		B[2][2][2]=2;
	//------------------------------B[2] ---------------
	B[3][0][0]=1;		B[3][0][1]=2;		B[3][0][2]=0;
	B[3][1][0]=1;		B[3][1][1]=1;		B[3][1][2]=0;
	B[3][2][0]=1;		B[3][2][1]=2;		B[3][2][2]=0;
	//------------------------------B[3] ---------------
	B[4][0][0]=1;		B[4][0][1]=1;		B[4][0][2]=2;
	B[4][1][0]=1;		B[4][1][1]=1;		B[4][1][2]=0;
	B[4][2][0]=2;		B[4][2][1]=0;		B[4][2][2]=0;
	//------------------------------B[4] ---------------
	B[5][0][0]=1;		B[5][0][1]=1;		B[5][0][2]=1;
	B[5][1][0]=2;		B[5][1][1]=1;		B[5][1][2]=2;
	B[5][2][0]=0;		B[5][2][1]=0;		B[5][2][2]=0;
	//------------------------------B[5] ---------------
	B[6][0][0]=2;		B[6][0][1]=1;		B[6][0][2]=1;
	B[6][1][0]=0;		B[6][1][1]=1;		B[6][1][2]=1;
	B[6][2][0]=0;		B[6][2][1]=0;		B[6][2][2]=2;
	//------------------------------B[6] ---------------
	B[7][0][0]=0;		B[7][0][1]=2;		B[7][0][2]=1;
	B[7][1][0]=0;		B[7][1][1]=1;		B[7][1][2]=1;
	B[7][2][0]=0;		B[7][2][1]=2;		B[7][2][2]=1;
	//------------------------------B[7] ---------------
	B[8][0][0]=0;		B[8][0][1]=0;		B[8][0][2]=2;
	B[8][1][0]=0;		B[8][1][1]=1;		B[8][1][2]=1;
	B[8][2][0]=2;		B[8][2][1]=1;		B[8][2][2]=1;
	//------------------------------B[8] ---------------
	for (o1=start_row;o1<im_height;o1++)
	{
	  for (o2=start_col;o2<im_width;o2++)
	  {
		 z=start_point+o1*im_width+o2;
		 ThinData[z]=(unsigned char) (ThresData[z]/255);
		 ThresData[z]=(unsigned char)(ThresData[z]/255);
	  }
	}
	Global=0;
	while (Global<9)
	{
	  for (g=1;g<9;g++)
	  {
		 flag=0;
		 for (o1=start_row+1; o1<im_height-1; o1++)
		 {
			for (o2=start_col+1; o2<im_width-1; o2++)
			{
			  change=1;
			  for (o4=1; o4<4; o4++)
			  {
				 for (o5=1; o5<4; o5++)
				 {
					t1=B[g][(int)o4-1][(int)o5-1];
					if (t1<2)
					{
						t2=(int)ThresData[start_point+(o1+o4-2)*im_width+o2+o5-2];
						if (t1!=t2) change=0;
					}
				 }
			  }
			  t1=1;
			  if ( change==1)
			  {
				  t1=0;
				  flag=1;
				  ThinData[start_point+o1*im_width+o2]=(unsigned char)t1;
			  }
			}
		 }
		 for (o1=start_row+1; o1<im_height-1; o1++)
		 {
			for (o2=start_col+1; o2<im_width-1; o2++)
			{
			  ThresData[start_point+o1*im_width+o2]=ThinData[start_point+o1*im_width+o2];
			}
		 }
		 if (flag==0) Global++;
		 else Global=0;
	  }
	  for (o1=start_row+1; o1<im_height; o1++)
	  {
		 for (o2=start_col+1; o2<im_width; o2++)
		 {
			uch1=ThinData[start_point+o1*im_width+o2];
			ThresData[start_point+o1*im_width+o2]=uch1;
			t1=(int)uch1;
		 }

	  }
	}
	for (o1=start_row;o1<im_height;o1++)
	{
	  for(o2=start_col;o2<im_width;o2++)
	  {
		 z=start_point+o1*im_width+o2;
		 ThresData[z]=(unsigned char)(ThresData[z]*255);
	  }
	}
	GlobalFreePtr(ThinData);
}
void Delete()
{
	long i,j,z,v,w=im_width;
	int i1,j1,number,k;
	for (i=0;i<w;i++)
	{
	  for (j=0;j<w;j++)
	  {
		 z=start_point+i*w+j;
		 if (ThresData[z]==0)
		 {
			 number=perform_ridge(ThresData,i,j);
			 if (number==1) ThresData[z]=255;
			 if (number>=3)
			 {
				ThresData[z]=(unsigned char)255;
				for (i1=-1;i1<=1;i1++)
				{
				  for (j1=-1;j1<=1;j1++)
				  {
					 z=start_point+(i+i1)*w+j+j1;
					 if (ThresData[z]==0)
					 {
						 if (perform_ridge(ThresData,i+i1,j+j1)<=2)
						 {
							z=start_point+i*w+j;
							ThresData[z]=(unsigned char)0;
							i1=2;j1=2;
						 }
					 }
				  }
				}
			 }
			 if (number==3)
			 {
				z=start_point+i*w+j;
				if (ThresData[z-1]==0 && ThresData[z-w]==0) ThresData[z]=255;
				if (ThresData[z-1]==0 && ThresData[z+w]==0) ThresData[z]=255;
				if (ThresData[z+1]==0 && ThresData[z-w]==0) ThresData[z]=255;
				if (ThresData[z+1]==0 && ThresData[z+w]==0) ThresData[z]=255;
				if (ThresData[z+w]==0 && ThresData[z+w+1]==0) ThresData[z]=255;
				if (ThresData[z+w]==0 && ThresData[z+w-1]==0) ThresData[z]=255;
				if (ThresData[z-1]==0 && ThresData[z-1-w]==0) ThresData[z]=255;
				if (ThresData[z-1]==0 && ThresData[z-1+w]==0) ThresData[z]=255;
				if (ThresData[z-w]==0 && ThresData[z-w+1]==0) ThresData[z]=255;
				if (ThresData[z-w]==0 && ThresData[z-w-1]==0) ThresData[z]=255;
				if (ThresData[z-1]==0 && ThresData[z-1+w]==0) ThresData[z]=255;
				if (ThresData[z+1]==0 && ThresData[z+w+1]==0) ThresData[z]=255;
			 }
		 }
	  }
	}
	return;

}
void Delete_bif1()
{
	long i,j,z,w=im_width,xpos,ypos;
	int i1,j1,number,k,l,point,end_while;
	long *T=(long *)GlobalAllocPtr(GHND,10*sizeof(long));
	for (i=0;i<w;i++)
	{
	  for (j=0;j<w;j++)
	  {
		 z=start_point+i*w+j;
		 if (ThresData[z]==0)
		 {
			 number=perform_ridge(ThresData,i,j);
			 if (number==2)
			 {
				point=0;
				xpos=i;ypos=j;
				end_while=1;
				while(end_while==1)
				{
					end_while=0;
					number=perform_ridge(ThresData,xpos,ypos);
					if (number<3)
					{
					  z=start_point+xpos*w+ypos;
					  T[point]=z;ThresData[z]=255;
					  point++;
					  if (point <=8)
					  {
						  for (k=-1;k<=1;k++)
						  {
							 for (l=-1;l<=1;l++)
							 {
								z=start_point+(xpos+k)*w+ypos+l;
								if (ThresData[z]==0)
								{
								  xpos=xpos+k;
								  ypos=ypos+l;
								  k=2;l=2;
								  end_while=1;
								}
							 }
						  }
					  }
					  else end_while=0;
					}
					else end_while=0;
				}
				if (point>=8)
				{
				  for (k=0;k<point;k++) ThresData[T[k]]=(unsigned char) 0;
				}
			 }
		 }
	  }
	}

}

void Feature()
{
	long i,j,z,w=im_width;
	int i1,j1,number,k;
	int angle;
	int featNumber=0;
	unsigned char huge *Temp=(unsigned char huge*)GlobalAllocPtr(GHND,number_of_bytes);
	int *Y=(int *)GlobalAllocPtr(GHND,500*sizeof(int));
	int *X=(int *)GlobalAllocPtr(GHND,500*sizeof(int));
	int *ANGLE=(int *)GlobalAllocPtr(GHND,500*sizeof(int));
	int *TYPE=(int *)GlobalAllocPtr(GHND,500*sizeof(int));
	FILE *fp;
	fp=fopen("Original.dat","wb");
	for (i=35;i<w-35;i++)
	{
	  for (j=35;j<w-35;j++)
	  {
		 z=start_point+i*w+j;
		 if (ThresData[z]==0)
		 {
			 number=perform_ridge(ThresData,i,j);
			 if (number==2)
			 {
				k=(int)(i/16)*32+(int)j/16;
				if (Ridge_16[k]==0) angle=0;
				if (Ridge_16[k]==5) angle=1;
				if (Ridge_16[k]==6) angle=2;
				if (Ridge_16[k]==7) angle=3;
				if (Ridge_16[k]==4) angle=4;
				if (Ridge_16[k]==3) angle=5;
				if (Ridge_16[k]==2) angle=6;
				if (Ridge_16[k]==1) angle=7;
				ANGLE[featNumber]=angle;
				TYPE[featNumber]=0;
				X[featNumber]=(int) j;
				Y[featNumber]=(int) i;
				featNumber++;
				for (i1=-2;i1<=2;i1++)
				{
				  for (j1=-2;j1<=2;j1++)
				  {
					 z=start_point+(i+i1)*w+j+j1;
					 if (ThresData[z]==255) ThresData[z]=20;
				  }
				}
			 }

			 if (number>=4)
			 {
				if (perform2(ThresData,i,j)==0)
				{
				  k=(int)(i/16)*32+(int)j/16;
				  if (Ridge_16[k]==0) angle=0;
				  if (Ridge_16[k]==5) angle=1;
				  if (Ridge_16[k]==6) angle=2;
				  if (Ridge_16[k]==7) angle=3;
				  if (Ridge_16[k]==4) angle=4;
				  if (Ridge_16[k]==3) angle=5;
				  if (Ridge_16[k]==2) angle=6;
				  if (Ridge_16[k]==1) angle=7;
				  ANGLE[featNumber]=angle;
				  TYPE[featNumber]=1;
				  X[featNumber]=(int) j;
				  Y[featNumber]=(int) i;
				  featNumber++;
				  for (i1=-3;i1<=3;i1++)
				  {
					 for (j1=-3;j1<=3;j1++)
					 {
					  z=start_point+(i+i1)*w+j+j1;
					  if (ThresData[z]==255) ThresData[z]=150;
					 }
				  }
				}
			 }
		 }
	  }
	}

	for (i=0;i<w;i++)
	{
	  for (j=0;j<w;j++)
	  {
		 z=start_point+i*w+j;
		 Temp[z-start_point]=ThresData[z];
	  }
	}
	for (i=0;i<w;i++)
	{
	  for (j=0;j<w;j++)
	  {
		 z=i*w+j;
		 ThresData[z]=Temp[z];
	  }
	}

	fwrite(&featNumber,sizeof(int),1,fp);
	for (k=0;k<featNumber;k++)
	{
	  fwrite(&Y[k],sizeof(int),1,fp);
	  fwrite(&X[k],sizeof(int),1,fp);
	  fwrite(&TYPE[k],sizeof(int),1,fp);
	  fwrite(&ANGLE[k],sizeof(int),1,fp);
	}
	fclose(fp);
	fclose(fp);
	GlobalFreePtr(Temp);


}
void Connect()
{
	long i,j,z,w=im_width,xpos,ypos;
	int i1,j1,number,l,end_while,point,k,k1;
	int deltax,deltay,end;
	long *T=(long *)GlobalAllocPtr(GHND,20*sizeof(long));
	for (i=0;i<w;i++)
	{
	  for (j=0;j<w;j++)
	  {
		 z=start_point+i*w+j;
		 if (ThresData[z]==0)
		 {
			 number=perform_ridge(ThresData,i,j);
			 if (number==2)
			 {
				point=0;
				xpos=i;ypos=j;
				deltax=(int) xpos;deltay=(int) ypos;
				end_while=1;
				while (end_while==1)
				{
				  end_while=0;
				  z=start_point+xpos*w+ypos;
				  T[point]=z;ThresData[z]=255;
				  point++;
				  if (point<=8)
				  {
					 for (i1=-1;i1<=1;i1++)
					 {
						for (j1=-1;j1<=1;j1++)
						{
						  z=start_point+(xpos+i1)*w+ypos+j1;
						  if (ThresData[z]==0)
						  {
							 xpos=xpos+i1;ypos=ypos+j1;
							 end_while=1;i1=2;j1=2;
						  }
						}
					 }
				  }
				  else
				  {
					  end_while=0;
					  point=8;
				  }
				}
				deltax=(int)xpos-deltax;
				deltay=(int)ypos-deltay;
				end=0;
				if (deltax<=0)
				{
				  if (deltay<=0)
				  {
					 for (l=1;l<=3;l++)
					 {
						if (perform1(ThresData,i+l,j+l)==0)
						{
						  for (k=1;k<=l;k++)
						  {
							 z=start_point+(i+k)*w+j+k;
							 point++;
							 T[point]=z;
							 end=1;
						  }
						  l=4;
						}
					 }
					 if (end==0)
					 {
						 for (l=1;l<=3;l++)
						 {
							if (perform1(ThresData,i,j+l)==0)
							{
							  for (k=1;k<=l;k++)
							  {
								 z=start_point+i*w+j+k;
								 point++;
								 T[point]=z;
								 end=1;
							  }
							  l=4;
						  }
						}
					 }
					 if (end==0)
					 {
						 for (l=1;l<=3;l++)
						 {
							if (perform1(ThresData,i+l,j)==0)
							{
							  for (k=1;k<=l;k++)
							  {
								 z=start_point+(i+k)*w+j;
								 point++;
								 T[point]=z;
								 end=1;
							  }
							  l=4;
						  }
						}
					 }
					 if (end==0)
					 {
						 for (l=1;l<=3;l++)
						 {
							if (perform1(ThresData,i-l,j+l)==0)
							{
							  for (k=1;k<=l;k++)
							  {
								 z=start_point+(i-k)*w+j+k;
								 point++;
								 T[point]=z;
								 end=1;
							  }
							  l=4;
							}
						 }
					 }
				  }
				  else
				  {
					 for (l=1;l<=3;l++)
					 {
						if (perform1(ThresData,i+l,j-l)==0)
						{
						  for (k=1;k<=l;k++)
						  {
							 z=start_point+(i+k)*w+j-k;
							 point++;
							 T[point]=z;
							 end=1;
						  }
						  l=4;
						}
					 }
					 if (end==0)
					 {
						 for (l=1;l<=3;l++)
						 {
							if (perform1(ThresData,i,j-l)==0)
							{
							  for (k=1;k<=l;k++)
							  {
								 z=start_point+i*w+j-k;
								 point++;
								 T[point]=z;
								 end=1;
							  }
							  l=4;
						  }
						}
					 }
					 if (end==0)
					 {
						 for (l=1;l<=3;l++)
						 {
							if (perform1(ThresData,i+l,j)==0)
							{
							  for (k=1;k<=l;k++)
							  {
								 z=start_point+(i+k)*w+j;
								 point++;
								 T[point]=z;
								 end=1;
							  }
							  l=4;
						  }
						}
					 }
					 if (end==0)
					 {
						for (l=1;l<=3;l++)
						{
						  if (perform1(ThresData,i+l,j+l)==0)
						  {
							 for (k=1;k<=l;k++)
							 {
								z=start_point+(i+k)*w+j+k;
								point++;
								T[point]=z;
								end=1;
							 }
							 l=4;
						  }
						}
					 }
				  }
				}
				else
				{
				  if (deltay<=0)
				  {
					 for (l=1;l<=3;l++)
					 {
						if (perform1(ThresData,i-l,j+l)==0)
						{
						  for (k=1;k<=l;k++)
						  {
							 z=start_point+(i-k)*w+j+k;
							 point++;
							 T[point]=z;
							 end=1;
						  }
						  l=4;
						}
					 }

					 if (end==0)
					 {
						 for (l=1;l<=3;l++)
						 {
							if (perform1(ThresData,i,j+l)==0)
							{
							  for (k=1;k<=l;k++)
							  {
								 z=start_point+i*w+j+k;
								 point++;
								 T[point]=z;
								 end=1;
							  }
							  l=4;
						  }
						}
					 }
					 if (end==0)
					 {
						 for (l=1;l<=3;l++)
						 {
							if (perform1(ThresData,i-l,j)==0)
							{
							  for (k=1;k<=l;k++)
							  {
								 z=start_point+(i-k)*w+j;
								 point++;
								 T[point]=z;
								 end=1;
							  }
							  l=4;
						  }
						}
					 }
					 if (end==0)
					 {
						for (l=1;l<=3;l++)
						{
						  if (perform1(ThresData,i-l,j-l)==0)
						  {
							 for (k=1;k<=l;k++)
							 {
								z=start_point+(i-k)*w+j-k;
								point++;
								T[point]=z;
								end=1;
							 }
							 l=4;
						  }
						}
					 }
					 if (end==0)
					 {
						for (l=1;l<=3;l++)
						{
						  if (perform1(ThresData,i+l,j+l)==0)
						  {
							 for (k=1;k<=l;k++)
							 {
								z=start_point+(i+k)*w+j+k;
								point++;
								T[point]=z;
								end=1;
							 }
							 l=4;
						  }
						}
					 }
				  }
				  else
				  {
					 for (l=1;l<=3;l++)
					 {
						if (perform1(ThresData,i-l,j-l)==0)
						{
						  for (k=1;k<=l;k++)
						  {
							 z=start_point+(i-k)*w+j-k;
							 point++;
							 T[point]=z;
							 end=1;
						  }
						  l=4;
						}
					 }
					 if (end==0)
					 {
						 for (l=1;l<=3;l++)
						 {
							if (perform1(ThresData,i,j-l)==0)
							{
							  for (k=1;k<=l;k++)
							  {
								 z=start_point+i*w+j-k;
								 point++;
								 T[point]=z;
								 end=1;
							  }
							  l=4;
						  }
						}
					 }
					 if (end==0)
					 {
						 for (l=1;l<=3;l++)
						 {
							if (perform1(ThresData,i-l,j)==0)
							{
							  for (k=1;k<=l;k++)
							  {
								 z=start_point+(i-k)*w+j;
								 point++;
								 T[point]=z;
								 end=1;
							  }
							  l=4;
						  }
						}
					 }
				  }
				}
				if (point>=8) Delete_bifurcation(T[point]);
				for (k=0;k<=point;k++)
				{
					z=T[k];
					ThresData[z]=0;
				}
			 }
		 }
	  }
	}
	return;
}
void SORT(float *arr,int n)
{
	int i,j;
	float a;
	for (i=1;i<=n;i++)
	{
	  a=arr[i];
	}
	for (j=2;j<=n;j++)
	{
	  a=arr[j];
	  i=j-1;
	  while (i>0 && arr[i] >a)
	  {
		 arr[i+1]=arr[i];
		 i--;
	  }
	  arr[i+1]=a;
	}
	for (i=1;i<=n;i++)
	{
	  a=arr[i];
	}
	return;
}
void Delete_bifurcation(long v)
{
	 long z,w=(long)im_width;
	 int i1,j1,k,l,number=0,end_while;
	 long *Temp=(long *)GlobalAllocPtr(GHND,10*sizeof(long));
	 long xpos,ypos,m,n,xpos1,ypos1;
	 xpos=(v-start_point)/w;
	 ypos=v-start_point-xpos*w;
	 for (i1=-1;i1<=1;i1++)
	 {
		for (j1=-1;j1<=1;j1++)
		{
			z=start_point+(xpos+i1)*w+ypos+j1;
			if (ThresData[z]==0)
			{
				xpos=xpos+i1;ypos=ypos+j1;
				i1=2;j1=2;
			}
		}
	 }
	 if (perform_ridge(ThresData,xpos,ypos)>=3)
	 {
		z=start_point+xpos*w+ypos;
		Temp[0]=z;ThresData[z]=255;
		for (i1=-1;i1<=1;i1++)
		{
		  for (j1=-1;j1<=1;j1++)
		  {
			  z=start_point+(xpos+i1)*w+ypos+j1;
			  if (ThresData[z]==0)
			  {
				 end_while=1;
				 xpos1=xpos+i1;ypos1=ypos+j1;
				 number=1;
				 Temp[number]=z;ThresData[z]=255;
				 number++;
				 while (end_while==1)
				 {
					 end_while=0;
					 for (k=-1;k<=1;k++)
					 {
						for (l=-1;l<=1;l++)
						{
						  z=start_point+(xpos1+k)*w+ypos1+l;
						  if (ThresData[z]==0)
						  {
							  xpos1=xpos1+k;ypos1=ypos1+l;
							  Temp[number]=z;ThresData[z]=255;
							  number++;
							  k=2;l=2;end_while=1;
							  if (number>6) end_while=0;
						  }
						}
					 }

				 }
				 if (number>6)
				 {
					end_while=0;
					for(k=1;k<=6;k++)
					{
						z=Temp[k];ThresData[z]=0;
					}
				 }
			  }
		  }
		}
		z=Temp[0];
		ThresData[z]=0;
	 }
}



